/*Lee del sensor de temperatura DS18D20
16 muestras, una por cada segundo, mostrando
cada una de ellas el numero de muestra y
su valor en el LCD. Al final nos
muestra el promedio de las 16 lecturas, con 
el formato PROM= 30.2C*/

#include <p18cxxx.h>
#include <delays.h>
#include <stdio.h>		//librera sprintf()
#include <stdlib.h>		//libreras atoi(),atof()
#include "18F2550BOLT.h"
#include "ONEWIRE-BOLT.h"

extern void _startup( void ); // See c018i.c in your C18 compiler dir 
#pragma code _RESET_INTERRUPT_VECTOR = 0x000800 
void _reset( void ) 
{ 
    _asm goto _startup _endasm 
} 

#pragma code

float a;
float temp[20];
int entero,decimal,c,i;
char array[10];
char promedio[]="PROM=";

float prom_temp(float *arreglo);
 
void main()
{
init_bolt( );
InitLCD( );
	for (i=0; i<16; i++)
	{
		GotoXY(0,0);
		temp[i] = ds1820_read();
		sprintf(array,"%2d",i+1);
		PrintString(array);
		GotoXY(1,0);
		entero = temp[i];
		decimal = (temp[i]-entero) * 10;
		sprintf(array,"%2d.%d %cC", entero, decimal, 214);
		PrintString(array);
		delay_ms(2000);
	}
	GotoXY(0,0);
	PrintString(promedio);
	GotoXY(1,0);
	a = prom_temp(temp);
	entero = a;
	decimal= (a-entero)*10;
	sprintf(array,"%2d.%d %cC", entero,decimal,214);
	PrintString(array);
	while(1);
	
} 

float prom_temp(float *arreglo)
{
	float promedio=0;
	int i;
	for(i=0; i<16; i++)
	{
		promedio += *(arreglo+i); //promedio= promedio + *(arreglo+i);
	}
	return promedio/16;
}

